#include "param.h"

double metropolis(float *image,float* grad,float **svm_proba)
{
  int i=0;
  int ri,rj;
  int l;
  int old;
  float t=TINIT;
  float energy,new_energy,delta;
  srand (time (NULL));
  /*Random number generation initialization*/
  const  gsl_rng *r =gsl_rng_alloc(gsl_rng_env_setup()) ; 

  /*Compute the initial energie of the image*/
  energy= E(image,grad,svm_proba);
  
  /*Begin of the Metropolos algorithm*/
  /*Initial Temperature= T*/
  


while(t>0.1){
    while(i<TRY){    
      ri=gsl_rng_uniform_int(r,H);
      rj=gsl_rng_uniform_int(r,W);
      old=image[ri*W+rj];
      do{
	l = 1 + gsl_rng_uniform_int(r,NBL);
      }while(l==old);
      energy=local_energy(image,ri,rj,old,grad,svm_proba);
      new_energy=local_energy(image,ri,rj,l,grad,svm_proba);
      delta=new_energy-energy;
      if(delta<0)
	image[ri*W+rj]=l;
      else if(exp(-(float)delta/t) >((float) rand()/ RAND_MAX) )
	image[ri*W+rj]=l; 
      i++;
    }
    i=0;
    if(PRINT_CONFIG==1)
      P(image,t);
    else
      Save_Label(image);
      
    energy= E(image,grad,svm_proba);
    //printf("\nEnergy at t=%f ;%f\n",t,energy);
   printf("%f\n",energy);
    t=t*K;
  }
  Save_Label(image);


  return 0;
}

	
	
    
    
  
