#include "param.h"

int convert_hyper_HIN(float *data,int w,int h){
  int i,j,n;
  
  FILE *f=fopen("classification.ppm","w");
  
  fprintf(f, "P6\n");
  fprintf(f, "%d %d\n",w, h); // Write size
  fprintf(f, "255\n"); // Write the max of the image
  int col;
  for(i=0;i<w*h;i++){
    switch((int)data[i])
      {               
      case(1):
	col = 0<< 16 | 255 << 8 |255;
	fwrite(&col, 1, 3, f);
	break;
      case(2):
	col = 0<< 16 | 238 << 8 | 238;
	fwrite(&col, 1, 3, f);
	break;
      case(3):
	col = 0<< 16 | 139 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(4):
	col = 0<< 16 | 0 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      case(5):
	col = 0<< 16 | 205 << 8 | 205;
	fwrite(&col, 1, 3, f);
	break;
      case(6):
	col = 0<< 16 | 255 << 8 | 127;
	fwrite(&col, 1, 3, f);
	break;
      case(7):
	col = 0<< 16 | 205<< 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(8):
	col = 45<< 16 | 82 << 8 | 160;
	fwrite(&col, 1, 3, f);
	break;
      case(9):
	col = 255<< 16 | 255 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
case(10):
	col = 96<< 16 | 48 << 8 | 176;
	fwrite(&col, 1, 3, f);
	break;
case(11):
	col = 0<< 16 | 139 << 8 | 139;
	fwrite(&col, 1, 3, f);
	break;
case(12):
	col = 205<< 16 | 0 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
   case(13):
	col = 0<< 16 | 0 << 8 | 139;
	fwrite(&col, 1, 3, f);
	break;
   case(14):
	col = 255<< 16 | 0 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      }
  }
  
  fclose(f);
  return 0;
}

int convert_hyper_uni(float *data,int w,int h){
  int i,j,n;
  
  FILE *f=fopen("classification.ppm","w");
  
  fprintf(f, "P6\n");
  fprintf(f, "%d %d\n",w, h); // Write size
  fprintf(f, "255\n"); // Write the max of the image
  int col;
  for(i=0;i<w*h;i++){
    switch((int)data[i])
      {               
      case(1):
	col = 192<< 16 | 192 << 8 |192;
	fwrite(&col, 1, 3, f);
	break;
      case(2):
	col = 0<< 16 | 255 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(3):
	col = 255<< 16 | 255 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(4):
	col = 0<< 16 | 128 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(5):
	col = 255<< 16 | 0 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      case(6):
	col = 41<< 16 | 82 << 8 | 165;
	fwrite(&col, 1, 3, f);
	break;
      case(7):
	col = 128<< 16 | 0<< 8 | 128;
	fwrite(&col, 1, 3, f);
	break;
      case(8):
	col = 0<< 16 | 0 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      case(9):
	col = 0<< 16 | 255 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      }
  }
  
  fclose(f);
  return 0;
}

int convert_hyper_in(float *data,int w,int h){
  int i,j,n;
  
  FILE *f=fopen("classification.ppm","w");
  
  fprintf(f, "P6\n");
  fprintf(f, "%d %d\n",w, h); // Write size
  fprintf(f, "255\n"); // Write the max of the image
  int col;
  for(i=0;i<w*h;i++){
    switch((int)data[i])
      {               
      case(1):
	col = 241<< 16 | 28 << 8 |3;
	fwrite(&col, 1, 3, f);
	break;
      case(2):
	col = 1<< 16 | 89 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      case(3):
	col = 133<< 16 | 255 << 8 | 5;
	fwrite(&col, 1, 3, f);
	break;
      case(4):
	col = 158<< 16 | 78 << 8 | 160;
	fwrite(&col, 1, 3, f);
	break;
      case(5):
	col = 255<< 16 | 173 << 8 | 101;
	fwrite(&col, 1, 3, f);
	break;
      case(6):
	col = 112<< 16 | 91 << 8 | 60;
	fwrite(&col, 1, 3, f);
	break;
      case(7):
	col = 137<< 16 | 254<< 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      case(8):
	col = 251<< 16 | 2 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      case(9):
	col = 255<< 16 | 1 << 8 | 89;
	fwrite(&col, 1, 3, f);
	break;
      case(10):
	col = 255<< 16 | 171 << 8 | 3;
	fwrite(&col, 1, 3, f);
	break;
      case(11):
	col = 7<< 16 | 255 << 8 | 12;
	fwrite(&col, 1, 3, f);
	break;
      case(12):
	col = 84<< 16 | 175 << 8 | 172;
	fwrite(&col, 1, 3, f);
	break;
      case(13):
	col = 63<< 16 | 192 << 8 | 104;
	fwrite(&col, 1, 3, f);
	break;
      case(14):
	col = 46<< 16 | 69 << 8 | 139;
	fwrite(&col, 1, 3, f);
	break;
      case(15):
	col = 172<< 16 | 255 << 8 | 119;
	fwrite(&col, 1, 3, f);
	break;
      case(16):
	col = 3<< 16 | 255 << 8 | 254;
	fwrite(&col, 1, 3, f);
	break;
      }
  }
  
  fclose(f);
  return 0;
}

int convert_hyper_he(float *data,int w,int h){
  int i,j,n;
  
  FILE *f=fopen("classification.ppm","w");
  
  fprintf(f, "P6\n");
  fprintf(f, "%d %d\n",w, h); // Write size
  fprintf(f, "255\n"); // Write the max of the image
  int col;
  for(i=0;i<w*h;i++){
    switch((int)data[i])
      {               
      case(1):
	col = 106<< 16 | 255 << 8 |255;
	fwrite(&col, 1, 3, f);
	break;
      case(2):
	col = 0<< 16 | 193 << 8 | 245;
	fwrite(&col, 1, 3, f);
	break;
      case(3):
	col = 0<< 16 | 153 << 8 | 211;
	fwrite(&col, 1, 3, f);
	break;
      case(4):
	col = 0<< 16 | 240 << 8 | 240;
	fwrite(&col, 1, 3, f);
	break;
      case(5):
	col = 0<< 16 | 220 << 8 | 224;
	fwrite(&col, 1, 3, f);
	break;
      case(6):
	col = 0<< 16 | 205 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(7):
	col = 230<< 16 | 50<< 8 | 50;
	fwrite(&col, 1, 3, f);
	break;
      case(8):
	col = 216<< 16 | 191 << 8 | 216;
	fwrite(&col, 1, 3, f);
	break;
      case(9):
	col = 240<< 16 | 32 << 8 | 160;
	fwrite(&col, 1, 3, f);
	break;
      case(10):
	col = 96<< 16 | 48 << 8 | 176;
	fwrite(&col, 1, 3, f);
	break;
      case(11):
	col = 255<< 16 | 255 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(12):
	col = 255<< 16 | 255 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      }
  }
  
  fclose(f);
  return 0;
}

int convert_hyper_center(int nc,int w,int h){
  int i,j,n;
  char ch[30];
  
  
  FILE *f1=fopen("image_classif","r");
  FILE *f=fopen("classification.ppm","w");

  
  fprintf(f, "P6\n");
  fprintf(f, "%d %d\n",w, h); // Write size
  fprintf(f, "255\n"); // Write the max of the image
  int col;
  while(!feof(f1)){
    fgets(ch,sizeof(ch),f1);                     
    switch(atoi(ch))
      {               
      case(1):
	col = 255<< 16 | 0 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(2):
	col = 0<< 16 | 128 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(3):
	col = 0<< 16 | 255 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(4):
	col = 0<< 16 | 0 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      case(5):
	col = 2<< 16 | 71 << 8 | 142;
	fwrite(&col, 1, 3, f);
	break;
      case(6):
	col = 192<< 16 | 192 << 8 | 192;
	fwrite(&col, 1, 3, f);
	break;
      case(7):
	col = 255<< 16 | 255<< 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(8):
	col = 0<< 16 | 110 << 8 | 246;
	fwrite(&col, 1, 3, f);
	break;
      case(9):
	col = 0<< 16 | 255 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      }
  }

  fclose(f);
  fclose(f1);
  return 0;
}

int convert_toulouse(float *data,int w,int h){
  int i,j,n;
  
  FILE *f=fopen("classification.ppm","w");
  
  fprintf(f, "P6\n");
  fprintf(f, "%d %d\n",w, h); // Write size
  fprintf(f, "255\n"); // Write the max of the image
  int col;
  for(i=0;i<w*h;i++){
    switch((int)data[i])
      {               
      case(1):
	col = 255<< 16 | 0 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(3):
	col = 0<< 16 | 0 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      case(2):
	col = 0<< 16 | 34 << 8 | 128;
	fwrite(&col, 1, 3, f);
	break;
      case(4):
	col = 0<< 16 | 255 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      }
  }
  fclose(f);
  return 0;
}

int convert_hyper_purdue(int nc,int w,int h){
  int i,j,n;
  char ch[30];
  
  
  FILE *f1=fopen("image_classif","r");
  FILE *f=fopen("classification.ppm","w");

  
  fprintf(f, "P6\n");
  fprintf(f, "%d %d\n",w, h); // Write size
  fprintf(f, "255\n"); // Write the max of the image
  int col;
  while(!feof(f1)){
    fgets(ch,sizeof(ch),f1);                     
    switch(atoi(ch))
      {               
      case(2):
	col = 0<< 16 | 125 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(7):
	col = 0<< 16 | 255 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(4):
	col = 0<< 16 | 0 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      case(6):
	col = 128<< 16 | 128 << 8 | 128;
	fwrite(&col, 1, 3, f);
	break;
      case(1):
	col = 255<< 16 | 0 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(5):
	col = 255<< 16 | 128 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(3):
	col = 0<< 16 | 64<< 8 | 128;
	fwrite(&col, 1, 3, f);
	break;
      case(8):
	col = 0<< 16 | 255 << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      }
  }

  fclose(f);
  fclose(f1);
  return 0;
}

int convert_hyper_dc(int nc,int w,int h){
  int i,j,n;
  char ch[30];
  
  
  FILE *f1=fopen("image_classif","r");
  FILE *f=fopen("classification.ppm","w");
 
  
  fprintf(f, "P6\n");
  fprintf(f, "%d %d\n",w, h); // Write size
  fprintf(f, "255\n"); // Write the max of the image
  int col;
  while(!feof(f1)){
    fgets(ch,sizeof(ch),f1);                     
    switch(atoi(ch))
      {               
      case(1):
	col = 102<< 16 | 102 << 8 | 204;
	fwrite(&col, 1, 3, f);
	break;
      case(2):
	col = 0<< 16 | 51 << 8 | 153;
	fwrite(&col, 1, 3, f);
	break;
      case(3):
	col = 0<< 16 | 153 << 8 | 204;
	fwrite(&col, 1, 3, f);
	break;
      case(4):
	col = 0<< 16 | 255 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(5):
	col = 0<< 16 | 102 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(6):
	col = 255<< 16 | 51 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(7):
	col = 153<< 16 | 153<< 8 | 153;
	fwrite(&col, 1, 3, f);
	break;
      }
  }

  fclose(f);
  fclose(f1);
  return 0;
}

int convert_ikonos(float *data,int w,int h){
  int i,j,n;
  
  FILE *f=fopen("classification.ppm","w");
  
  fprintf(f, "P6\n");
  fprintf(f, "%d %d\n",w, h); // Write size
  fprintf(f, "255\n"); // Write the max of the image
  int col;
  for(i=0;i<w*h;i++){
    switch((int)data[i])                   
      {               
      case(1):
	col = 146<< 16 | 146 << 8 | 151;
	fwrite(&col, 1, 3, f);
	break;
      case(2):
	col = 0<< 16 | 255 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(3):
	col = 0<< 16 | 64 << 8 | 128;
	fwrite(&col, 1, 3, f);
	break;
      case(4):
	col = 0<< 16 |0  << 8 | 255;
	fwrite(&col, 1, 3, f);
	break;
      case(6):
	col = 128<< 16 | 0 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      case(5):
	col = 128<< 16 | 128 << 8 | 0;
	fwrite(&col, 1, 3, f);
	break;
      }
  }

  fclose(f);
  return 0;
}
