#include <stdio.h>
#include <stdlib.h>
unsigned char* Read_pgm(const char * filename);

int confusion(const char *ref,const char *classif, int W, int H, int NC)
{
  int i,j;
  int Nel=0;
  char ch[256];
  float *aa_c;
  aa_c=(float*)calloc(NC,sizeof(float));
  
  float **confu;
  confu=(float**)calloc(NC,sizeof(float*));
  for(i=0;i<NC;i++)
    confu[i]=(float*)calloc(NC,sizeof(float));
  //
  //printf("Initialisation ok\n");
  //
  /*Loading data*/
  

//unsigned char* f_ref=Read_pgm(ref);
  
//unsigned char* f_ref;

FILE* fp;

fp = fopen(ref, "rb");

unsigned int AssignMemSize = W * H * sizeof(unsigned int);

unsigned int* test= (unsigned int*) malloc(AssignMemSize);

if (!fread(test, AssignMemSize, 1, fp)) {
		printf("Could not read file '%s'",ref);
		return 0;
	}
    fclose(fp);


for(i=0;i<W*H;i++)
    if(test[i]<100) test[i] = test[i]+1; else test[i]  = 0;



 // if(f_ref ==NULL)
 //   printf("Error in opening file ref");
  
  FILE *f_class=fopen(classif,"r");

if(f_class ==NULL)
    printf("Error in opening file classif");
  
  int *f_classif=(int*)calloc(W*H,sizeof(int));
  for(i=0;i<W*H;i++){
    fgets(ch,sizeof(ch),f_class);
    f_classif[i]=atoi(ch);
  }
  fclose(f_class);
  
  //
  printf("load data ok\n");
  //
  
  /*Compute the Confusion Matrice*/
  for(i=0;i<W*H;i++)
    if(test[i]!=0){
      confu[test[i]-1][f_classif[i]-1]=confu[test[i]-1][f_classif[i]-1]+1;//=confu[test][f_classif]+1;
      aa_c[test[i]-1]=aa_c[test[i]-1]+1;
      Nel++;
    }
    free(f_classif);
  //
  printf("Compute Confusion ok\n");
  //
  
  /*Compute the OA*/
  float oa=0;
  for(i=0;i<NC;i++)
    oa+=confu[i][i];
  oa=oa/Nel;
  printf("OA=%f\n",oa*100);
  
  /*Compute the AA_C*/
  for(i=0;i<NC;i++)
    aa_c[i]=confu[i][i]/aa_c[i];
  
  /*Compute the AA*/
  float aa=0;
  for(i=0;i<NC;i++)
    aa+=aa_c[i];
  aa=aa/NC;
  printf("AA=%f\n",aa*100);
  /*Compute the Kappa Coefficient*/
  float *tp1=(float*)calloc(NC,sizeof(float));
  float *tp2=(float*)calloc(NC,sizeof(float));
  float K=0;
  for(i=0;i<NC;i++){
    for(j=0;j<NC;j++){
      tp1[i]+=confu[i][j];
      tp2[i]+=confu[j][i];
    }
    K+=tp1[i]*tp2[i];
  }
  K=K/(Nel*Nel);
  K=(oa-K)/(1-K);

  printf("K=%f\n",K*100);
  /*Writting the results on the hard drive*/
  FILE *res=fopen("confu","w");
  if(res==NULL)
    printf("Error in opening file res");
  
  fprintf(res,"OA=\n %f\n",oa*100);
  fprintf(res,"AA=\n %f\n",aa*100);  
  fprintf(res,"Kappa=\n %f\n",K*100);
  fprintf(res,"AA_C\n");
  for(i=0;i<NC;i++)
    fprintf(res,"%f\n",aa_c[i]*100);
  fprintf(res,"Confu\n");
  for(i=0;i<NC;i++){
    for(j=0;j<NC;j++)
      fprintf(res,"%d\t",(int)confu[i][j]);
    fprintf(res,"\n");
  }
  fclose(res);
  free(confu);
free(test);
  free(aa_c);
  free(tp1);
  free(tp2);
    
  return 0;
}
      
  
      
      
    

    
  
