#include "param.h"

int main(void)
{
  int i;
  char ch[30];
  float *data_hyper,*grad;
  float *image=malloc(W*H*sizeof(float));  
  float ** svm_proba;
  FILE* f;

  
  /* Load data */
  printf("#######################\n");
  printf("Load Data:\n");
  data_hyper = load_file(NAME_DATA, W,  H, NB);

  /*Scaling and gradiant*/
  printf("Scaling between -1 and 1\n");
  data_hyper=scale(data_hyper,W,H,NB);
  printf("Computing the Gradiant\n");
  grad= gradiant(data_hyper,W,H,NB);
  if(grad==NULL)
    printf("Error in gradiant.c");
  
  /*Classification by SVM: pixel by pixel */
  printf("#######################\n");
  printf("Classification by SVM:\n");
 // print_train_set(data_hyper);
  
//  print_data_set(data_hyper);

//  train_svm();

//svm_proba = classification_svm();  

svm_proba = probaclassification_svm();  

/*load svm classified data*/

 
 f=fopen("image_classif","r");
  for(i=0;i<W*H;i++){
    fgets(ch,sizeof(ch),f);
    image[i]=atof(ch);
  }
  fclose(f);
  confusion(TEST,"image_classif", W, H, NC);
  system("mv -v confu confu_bf_mrf");


/*Print parameters data*/


  printf("Initial energy=%f\n",E(image,grad,svm_proba));
  
  printf("#######################\n");
  /*Simulated Annealing*/
  metropolis(image,grad,svm_proba);

  confusion(TEST,"image_classif_mrf", W, H, NC);
  system("mv -v confu confu_af_mrf");



  return 0;
}




